unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, db, FileUtil, Forms, Controls, Graphics, Dialogs, DBGrids,
  StdCtrls, ZConnection, ZDataset;

type

  { TForm1 }

  TForm1 = class(TForm)
    btnNew: TButton;
    btnPost: TButton;
    btnDelete: TButton;
    Datasource1: TDatasource;
    DBGrid1: TDBGrid;
    ZConnection1: TZConnection;
    ZQuery1: TZQuery;
    procedure btnNewClick(Sender: TObject);
    procedure btnPostClick(Sender: TObject);
    procedure btnDeleteClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ZQuery1BeforePost(DataSet: TDataSet);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  Form1: TForm1; 

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  ZConnection1.Connect;
  ZQuery1.SQL.Text := 'CREATE TABLE IF NOT EXISTS demo(';
  ZQuery1.SQL.Add(' ID INTEGER NOT NULL PRIMARY KEY,');
  ZQuery1.SQL.Add(' Bezeichnung VARCHAR(50),');
  ZQuery1.SQL.Add(' Zahl INTEGER,');
  ZQuery1.SQL.Add(' AendDatum DATETIME');
  ZQuery1.SQL.Add(');');
  ZQuery1.ExecSQL;
  ZQuery1.SQL.Text := 'SELECT * FROM demo';
  ZQuery1.Open;
  ZQuery1.FieldByName('Bezeichnung').DisplayWidth := 30;
end;

procedure TForm1.ZQuery1BeforePost(DataSet: TDataSet);
begin
  ZQuery1.FieldByName('AendDatum').AsDateTime := Now;
end;

procedure TForm1.btnNewClick(Sender: TObject);
begin
  If ZQuery1.State In [dsEdit, dsInsert] Then
    ZQuery1.Post;
  ZQuery1.Append;
end;

procedure TForm1.btnPostClick(Sender: TObject);
begin
  If ZQuery1.State In [dsEdit, dsInsert] Then
    ZQuery1.Post;
end;

procedure TForm1.btnDeleteClick(Sender: TObject);
begin
  If ZQuery1.State In [dsEdit, dsInsert] Then
    ZQuery1.Cancel
  Else ZQuery1.Delete;
end;

end.

